#include "ros/ros.h"

//Cabecera de nuestra librería
#include "sensor_fake/SensorFake.h"
//Cabecera de nuestro mensaje
#include "sensor_fake/XYZ.h"
 
 
 
void fillMsg(sensor_fake::XYZ &msg, int id, struct timeval timestamp, int x, int y, int z){
  
   msg.header.stamp = ros::Time::now();
   msg.header.seq = id;
   msg.timestamp.sec = timestamp.tv_sec;
   msg.timestamp.nsec = timestamp.tv_usec*1000;
   msg.x = x;
   msg.y = y;
   msg.z = z;
  
  
} 


int main(int argc, char **argv)
{
 
  
  ros::init(argc, argv, "SensorFake_Publisher"); // "SensorFake_Publisher" == Node name
  ros::NodeHandle n;
  int max_num_msgs_in_buffer = 1000;
  ros::Publisher sensor_fake_publisher = n.advertise<sensor_fake::XYZ>("SensorFake_Publisher_Topic", max_num_msgs_in_buffer);
  // // "SensorFake_Publisher" == Topic name
  ros::Rate loop_rate(10);
 
  int count = 0; //Número de mensaje
  
  struct timeval timestamp;
  int x, y, z;
  
  sensor_fake::XYZ msg;
  
  
  sensor_fake::SensorFake sensor_fake;
  sensor_fake.Connect();
 

  std::cout << "Hello, I am the SensorFake_Publisher" << std::endl;
  while (ros::ok())
  {

   
   if (sensor_fake.Read(timestamp, x, y, z)==-1){
     printf("Error while reading...\n");
   }
   else{
	printf("Time %ld.%ld: Sending x [%d] y [%d] z [%d]\n", timestamp.tv_sec, timestamp.tv_usec, x, y, z);
      fillMsg(msg, count++, timestamp,  x, y, z);
      sensor_fake_publisher.publish(msg);
  }
   
 
      ros::spinOnce();
     loop_rate.sleep();
 }


  return 0;
}
// %EndTag(FULLTEXT)%